package andante;

import java.io.*;
import java.util.*;
import java.net.InetAddress;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;

import andante.device.*;
import andante.stage.*;
import andante.orb.device.*;
import andante.orb.stage.*;


import com.ibm.aglet.*;
import com.ibm.aglet.event.*;
import java.net.*;

public class Main {

  public static void main(String args[]) {

    ORB Orb = null;

    try {

      AgletsServer.main(args);

      Properties props = new Properties();
      props.put("org.omg.CORBA.ORBInitialHost", "localhost");
      props.put("org.omg.CORBA.ORBInitialPort", "1050");
      Orb = org.omg.CORBA.ORB.init(args, props);
      run(Orb);

    }
    catch (Exception e) {
      e.printStackTrace();
    }

    (new OrbRun(Orb)).start();
    System.out.println("Ok.");
  }


  public static void run(ORB Orb) {
    try {
      NamingContextExt nc = NamingContextExtHelper.narrow
	(Orb.resolve_initial_references("NameService"));

      NamingContextExt ncAndante = resolve(nc, "andante");
      NamingContextExt ncDevices = resolve(ncAndante, "devices");;
      NamingContextExt ncStages = resolve(ncAndante, "stages");

      String StageName = InetAddress.getLocalHost().getHostName();
      int endIndex = StageName.indexOf('.');
      if (endIndex > 0)
        StageName = StageName.substring(0,endIndex);
      StageName += ":" + AgletsServer.getPortNum();
      System.out.println("Stage name: " + StageName);

      NamingContextExt ncLocal = resolve(ncStages, StageName);
      NamingContextExt ncAgents = resolve(ncLocal, "agents");;

//    AudioDeviceX daI = new AudioDeviceX();
      JavaMidiDevice adi = new JavaMidiDevice();
//      AlsaMidiDevice daI = new AlsaMidiDevice(65,0);
//      OscDevice daI = new OscDevice(InetAddress.getLocalHost(),4449);
      AudioDevice ad = null;

      StageImpl stageI = null;
      Stage stage = null;

      POA Poa = org.omg.PortableServer.POAHelper.narrow
	( Orb.resolve_initial_references("RootPOA"));
      Poa.the_POAManager().activate();
      org.omg.CORBA.Object obj = Poa.servant_to_reference(adi);
      ad = AudioDeviceHelper.narrow(obj);

      stageI = new StageImpl(StageName, ad, Poa);

      obj = Poa.servant_to_reference(stageI);
      stage = StageHelper.narrow(obj);

      ncLocal.rebind(nc.to_name("Metronome"), stage.getMetronome());

      AgletsServer.getContext().setProperty("Stage", stage);
      AgletsServer.getContext().setProperty("Orb", Orb);
      AgletsServer.getContext().setProperty("NamingContext", ncLocal);

    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public static NamingContextExt resolve(NamingContextExt nc, String name)
    throws Exception
  {
    NamingContextExt nc2 = null;
    try {
      nc2 = NamingContextExtHelper.narrow(nc.resolve(nc.to_name(name)));
    } catch (NotFound nf) {
      System.out.println("Binding '" + name + "'");
      nc.bind_new_context(nc.to_name(name));
      nc2 = NamingContextExtHelper.narrow(nc.resolve(nc.to_name(name)));
    }
    return nc2;
  }

}

class OrbRun extends Thread {
  ORB Orb;
  public OrbRun(ORB o) { Orb = o; }
  public void run() { Orb.run(); }
}

