package andante;

import com.ibm.aglet.*;
import com.ibm.aglet.event.*;
import java.io.*;
import java.net.*;

import andante.orb.*;
import andante.orb.stage.*;
import andante.orb.agent.*;
import java.util.*;

public class MAKeyboardProxyArp extends MAKeyboardProxy {

  private long [] T = new long[128];
  private int [] Deg = new int[128];
  private int [] ScaleSeed;
  private int [] ArpShape = {1,1,2};//,3,1,1,2};
  private int ScaleStart;
  
  private int LastPitch = -1;
  private int PlayMode = 0;

  public void init(Stage stage) {
    super.init(stage);
    for (int i = T.length - 1; i >= 0; i--) {
      T[i] = 0;
    }
    for (int i = Deg.length - 1; i >= 0; i--) {
      Deg[i] = -1;
    }
    ScaleStart = 60;
    ScaleSeed = Scales.getScaleSeed("Diatonic");

    int note = (ScaleStart % 12) - 12;
    int j = 0;
    while (note + ScaleSeed[j] < 0) {
      if (j == ScaleSeed.length - 1) {
        note += 12;
        j = 0;
      }
      else j++;
    } 
    while (note + ScaleSeed[j] < 128) {
      Deg[note + ScaleSeed[j]] = j;
      if (j == ScaleSeed.length - 1) {
        note += 12;
        j = 0;
      }
      else j++;
    } 
    for (int i = Deg.length - 1; i >= 0; i--) {
      System.out.println(i + " " + Deg[i]);
    }
    
  }

  public void processMessage (andante.orb.Message m) {
    if (m.type == MessageType.NOTE_ON) {
      if (Deg[m.data[0]] > -1) {
        if (m.data[1] != 0) {
          if (PlayMode == 0) {
            PlayMode = 1;
            T[m.data[0]] = System.currentTimeMillis();
            LastPitch = m.data[0];
            C.sendMessage(m);
          }
          else if (PlayMode == 1){
            if (m.data[0] > LastPitch)
              PlayMode = 2;
            else
              PlayMode = 3;
          }
        }
        else {
          C.sendMessage(m);
          if (T[m.data[0]] != 0) {
            if (PlayMode == 2)
              (new PlayArpAsc(LastPitch, 100)).start();
            else if (PlayMode == 3)
              (new PlayArpDesc(LastPitch, 100)).start();
          }
          PlayMode = 0;
        }
      }
    }
  }


  class PlayArpAsc extends Thread {
    protected int Pitch;
    protected int Intensity;

    public PlayArpAsc(int pitch, int intensity) {
      Pitch = pitch;
      Intensity = intensity;
    }
    public void run() {
      int dur = (int)(System.currentTimeMillis() - T[Pitch]);
      
      int j = Pitch;
      for (int i = 0; i < ArpShape.length; i++) {
        int step = 0;
        while (j < 128) {
          if (Deg[j] != -1) {
            if (step == ArpShape[i]) break;
            step++;
          }
          j++;
        }
        
        C.noteOn((short)j, (short)Intensity);
        try { Thread.sleep(dur); }
        catch (InterruptedException ie) { }
        C.noteOff((short)j, (short)Intensity);
      }
      T[Pitch] = 0;
    }

  }

  class PlayArpDesc extends PlayArpAsc {
    public PlayArpDesc(int pitch, int intensity) {
      super(pitch, intensity);
    }

    public void run() {
      int dur = (int)(System.currentTimeMillis() - T[Pitch]);
      
      int j = Pitch;
      for (int i = ArpShape.length - 1; i >=0; i--) {
        int step = 0;
        while (j < 128) {
          if (Deg[j] != -1) {
            if (step == ArpShape[i]) break;
            step++;
          }
          j--;
        }
        
        C.noteOn((short)j, (short)Intensity);
        try { Thread.sleep(dur); }
        catch (InterruptedException ie) { }
        C.noteOff((short)j, (short)Intensity);
      }
      T[Pitch] = 0;
    }

  }


}
