package andante.apps.noiseweaver;

public class BrownianNoise implements NumbersGenerator, java.io.Serializable {

  private int Previous;
  private int Min;
  private int Max;

  public BrownianNoise(int min, int max) {
    if (min > max) {
      int temp = max;
      max = min;
      min = temp;
    }
    Min = min;
    Max = max - min + 1;
    Previous = Max / 2;
  }

  public int next() {
    int res = brownianNoise(Previous);
    Previous = res;
    return res + Min;
  }

  public int max() { return Max + Min - 1; }
  public int min() { return Min; }

  public int brownianNoise(int previousPos) {
    double u = Math.random();
    int res = previousPos;

    if (u <= 0.4) {
      res++;
    }
    else if (u >= 0.6) {
      res--;
    }

    return ((res % Max) + Max) % Max;
  }


}
