package andante.apps.noiseweaver;

public class PinkNoise implements NumbersGenerator, java.io.Serializable {

  private int Min;
  private int Max;
  private int Previous;

  public PinkNoise(int min, int max) {
    if (min > max) {
      int temp = max;
      max = min;
      min = temp;
    }
    Min = min;
    Max = max - min + 1;
    Previous = Max / 2;
  }

  public int next() {
    int res = pinkNoise(Previous);
    Previous = res;
    return res + Min;
  }

  public int max() { return Max + Min + 1; }
  public int min() { return Min; }

  public int pinkNoise(int previousPos) {
    int newPos = 0, k, j, na;
    double prob, u;

    k = Max/2;

    prob = 1.0/k;

    na = previousPos;

    while (k >= 1) {
      j = na/k;
      if (j == 1) na -= k;
      u = Math.random();
      if (u < prob) j = 1-j;
      newPos += j*k;
      k /= 2;
      prob *= 2;
    }
    
    return newPos;
  }

  public static void main(String args[]) {
    PinkNoise r = new PinkNoise(Integer.parseInt(args[0]),Integer.parseInt(args[1]) );

    System.out.println(r.max() + " " + r.min());

    for (int i =  0; i < Integer.parseInt(args[2]); i++) {
      int foo = r.next();
      System.out.println(r.next());
      if (foo >= r.max() || foo < r.min())
	System.err.println(foo);
	
    }
  }

}
