package andante.apps.noiseweaver;

import java.util.*;

public class Scales {

  private static Hashtable ScaleSeeds;

  static {
    ScaleSeeds = new Hashtable();
    int diatonic[] =  {0, 2, 4, 5, 7, 9, 11};
    int wholeTone[] = {0, 2, 4, 6, 8, 10};
    int chromatic[] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11};
    int harmonicMinor[] = {0, 2, 3, 5, 7, 9, 11};
    int harmonicNatural[] = {0, 2, 3, 5, 7, 9, 11};
    int pentatonic[] = {0, 2, 4, 8, 10};
//    int blues[] = {0, 3, 5, 6, 7, 10};
    int blues[] = {0, 2, 3, 4, 7, 9};
    int pentablues[] = {0, 2, 4, 7, 9};
    int hirajoshi[] = {0, 2, 3, 7, 8};

    ScaleSeeds.put("Diatonic", diatonic);
    ScaleSeeds.put("WholeTone", wholeTone);
    ScaleSeeds.put("Chromatic", chromatic);
    ScaleSeeds.put("HarmonicMinor", harmonicMinor);
    ScaleSeeds.put("HarmonicNatural", harmonicNatural);
    ScaleSeeds.put("Pentatonic", pentatonic);
    ScaleSeeds.put("Blues", blues);
    ScaleSeeds.put("Pentablues", pentablues);
    ScaleSeeds.put("Hirajoshi", pentablues);
  }

  public static String[] getScales() {
    String [] res = new String[ScaleSeeds.keySet().size()];
    (new TreeSet(ScaleSeeds.keySet())).toArray(res);
    return res;
  }

  public Scales() {
    throw new Error("Can't be instantiated!");
  }
  
  public static void setScale(String s, int[] v) {
    if (ScaleSeeds.keySet().contains(s)) return; // FIXME (exception!)

    ScaleSeeds.put(s, v);
  }

  public static int[] getScaleSeed(String s) {
    // FIXME (for invalid 's')
    return (int [])ScaleSeeds.get(s);
  }

  public static int[] getScale(String s, int start, int numNotes) {
    if (!ScaleSeeds.keySet().contains(s)) return null; // FIXME (exception!)

    int [] seed = (int [])ScaleSeeds.get(s);
    int [] scale = new int[numNotes];
    int note = start;
    int j = 0;
    for (int i = 0; i < scale.length; i++) {
      scale[i] = note + seed[j];
      if (j == seed.length - 1) {
	note += 12;
	j = 0;
      }
      j++;
    }

    return scale;
  }


  public static void main(String args[]) {
    int harmonicMinor[] = {45, 2, 3, 5, 7, 9, 11};
    
  }
}
